return {
  {
    'norcalli/nvim-colorizer.lua',
    config = true,
    keys = { { '<leader>oc', '<Cmd>ColorizerToggle<Cr>', desc = 'Toggle colorizer' } },
    cmd = 'ColorizerToggle',
  },

  { 'AndrewRadev/linediff.vim', cmd = 'Linediff' },

  {
    'lukas-reineke/indent-blankline.nvim',
    event = 'VeryLazy',
    config = true,
    opts = {
      show_current_context = true,
      show_current_context_start = false,
      filetype_exclude = {
        'OverseerList',
        'OverseerForm',
        'lspinfo',
        'packer',
        'checkhealth',
        'help',
        'man',
        '',
      },
    },
  },

  {
    'chrisgrieser/nvim-various-textobjs',
    keys = {
      { 'ii', function() require('various-textobjs').indentation(true, true) end,   mode = { 'o', 'x' },
                                                                                                           desc =
        'Inside indent' },
      { 'ai', function() require('various-textobjs').indentation(false, false) end, mode = { 'o', 'x' },
                                                                                                           desc =
        'Around indent' },
      -- { 'iI', function() require('various-textobjs').indentation(true, true) end,   mode = { 'o', 'x' }, desc = '' },
      -- { 'aI', function() require('various-textobjs').indentation(false, false) end, mode = { 'o', 'x' }, desc = '' },
      { 'iS', function() require('various-textobjs').subword(true) end,             mode = { 'o', 'x' }, desc = '' },
      { 'aS', function() require('various-textobjs').subword(false) end,            mode = { 'o', 'x' }, desc = '' },
      { '|',  function() require('various-textobjs').column() end,                  mode = { 'o', 'x' }, desc = '' },
      { 'L',  function() require('various-textobjs').url() end,                     mode = { 'o', 'x' }, desc = '' },
      -- {"YOUR_MAPPING",function() require("various-textobjs").toNextClosingBracket() end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").restOfParagraph() end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").entireBuffer() end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").nearEoL() end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").lineCharacterwise() end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").value(true) end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").value(false) end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").key(true) end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").key(false) end, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").diagnostic() end, mode = { "o", "x" }, desc = "" },
      --------------------------------------------------------------------------------------
      -- put these into the ftplugins or autocms for the filetypes you want to use them with
      -- {"YOUR_MAPPING",function() require("various-textobjs").mdlink(true) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").mdlink(false) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      --
      -- {"YOUR_MAPPING",function() require("various-textobjs").mdFencedCodeBlock(true) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").mdFencedCodeBlock(false) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      --
      -- {"YOUR_MAPPING",function() require("various-textobjs").cssSelector(true) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").cssSelector(false) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      --
      -- {"YOUR_MAPPING",function() require("various-textobjs").htmlAttribute(true) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").htmlAttribute(false) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      --
      -- {"YOUR_MAPPING",function() require("various-textobjs").doubleSquareBrackets(true) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").doubleSquareBrackets(false) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      --
      -- {"YOUR_MAPPING",function() require("various-textobjs").shellPipe(true) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
      -- {"YOUR_MAPPING",function() require("various-textobjs").shellPipe(false) end, { buffer = true }, mode = { "o", "x" }, desc = "" },
    },
  },
  {
    'chrisgrieser/nvim-spider',
    keys = {
      { '<M-w>', function() require('spider').motion('w') end, mode = { 'n', 'o', 'x' }, desc = 'Spider-w' },
      { '<M-e>', function() require('spider').motion('e') end, mode = { 'n', 'o', 'x' }, desc = 'Spider-e' },
      { '<M-b>', function() require('spider').motion('b') end, mode = { 'n', 'o', 'x' }, desc = 'Spider-b' },
    },
  },

  {
    'echasnovski/mini.trailspace',
    version = '*',
    keys = {
      { '<leader>eT', function() MiniTrailspace.trim() end, desc = 'Trim whiltespace' },
    },
    config = true,
  },

  -- stolen from LazyVim
  {
    'stevearc/dressing.nvim',
    lazy = true,
    init = function()
      ---@diagnostic disable-next-line: duplicate-set-field
      vim.ui.select = function(...)
        require('lazy').load({ plugins = { 'dressing.nvim' } })
        return vim.ui.select(...)
      end
      ---@diagnostic disable-next-line: duplicate-set-field
      vim.ui.input = function(...)
        require('lazy').load({ plugins = { 'dressing.nvim' } })
        return vim.ui.input(...)
      end
    end,
  },

  {
    'stevearc/overseer.nvim',
    config = true,
    cmd = {
      'OverseerBuild',
      'OverseerClearCache',
      'OverseerClose',
      'OverseerDeleteBundle',
      'OverseerInfo',
      'OverseerLoadBundle',
      'OverseerOpen',
      'OverseerQuickAction',
      'OverseerRun',
      'OverseerRunCmd',
      'OverseerSaveBundle',
      'OverseerTaskAction',
      'OverseerToggle',
    },
    keys = {
      { '<leader>xx', '<Cmd>OverseerToggle<CR>',     desc = 'Overseer toggle' },
      { '<leader>xi', '<Cmd>OverseerInfo<CR>',       desc = 'Overseer info' },
      { '<leader>xa', '<Cmd>OverseerTaskAction<CR>', desc = 'Overseer action' },
      { '<leader>xr', '<Cmd>OverseerRun<CR>',        desc = 'Overseer run' },
    },
  },


  {
    'numToStr/Comment.nvim',
    config = true,
  },

  'editorconfig/editorconfig-vim',

  { 'dyng/ctrlsf.vim',          cmd = 'CtrlSF' },

  {
    'andymass/vim-matchup',
    event = 'BufRead',
    config = function()
      vim.g.matchup_matchparen_offscreen = {}
    end,
  },

  {
    'echasnovski/mini.surround',
    version = '*',
    event = 'BufEnter',
    config = true,
    main = 'mini.surround',
  },

  { 'fpob/nette.vim',   ft = 'nette' },
  { 'ziglang/zig.vim',  ft = 'zig' },
  { 'chrisbra/csv.vim', ft = 'csv' },

  {
    'mfussenegger/nvim-jdtls',
    ft = 'java',
  },

  {
    'folke/trouble.nvim',
    dependencies = { 'nvim-tree/nvim-web-devicons' },
    lazy = true,
    cmd = { 'Trouble', 'TroubleToggle' },
    keys = {
      { '<Leader>tt', '<Cmd>TroubleToggle<CR>',                desc = 'Trouble toggle' },
      { '<Leader>td', '<Cmd>Trouble document_diagnostics<CR>', desc = 'Trouble toggle' },
    },
    config = {
      mode = 'document_diagnostics',
      signs = {
        -- icons / text used for a diagnostic
        error = '',
        warning = '',
        hint = '',
        information = '',
        other = '',
      },
    },
  },

}
